#include "MiniGUI.ch"

Function main()
Private aComponentes:={}

DEFINE WINDOW Form_1 AT 0, 0 WIDTH 550 HEIGHT 350 TITLE "Movendo Componentes pela Janela" MAIN ON INIT Pega_Comp("Form_1")

     DEFINE TEXTBOX Text_1
            ROW    10
            COL    10
            WIDTH  300
            HEIGHT 24
            FONTNAME 'Arial'
            TOOLTIP ''
            INPUTMASK ''
            FORMAT ''
            VALUE ''
     END TEXTBOX 

     DEFINE COMBOBOX Combo_1
            ROW    10
            COL    350
            WIDTH  100
            HEIGHT 100
            ITEMS {'Opo 1','Opo 2'}
            FONTNAME 'Arial'
            TOOLTIP ''
     END COMBOBOX  

     DEFINE EDITBOX Edit_1
            ROW    90
            COL    10
            WIDTH  200
            HEIGHT 120
            VALUE ''
            FONTNAME 'Arial'
            TOOLTIP ''
            MAXLENGTH  NIL
     END EDITBOX  

END WINDOW

On Key UP    Of Form_1 Action Seta_cima("Form_1")
On Key DOWN  Of Form_1 Action Seta_baixo("Form_1")
On Key LEFT  Of Form_1 Action Seta_esq("Form_1")
On Key RIGHT Of Form_1 Action Seta_dir("Form_1")

Form_1.Center ; Form_1.Activate
Return Nil

**************************************************
Proc Seta_cima(cFormName)
Local cNomeComp:=_GetFocusedControl (cFormName), n_pos, n_row, n_col, lOk, i
n_pos:=Ascan( aComponentes, {|e| e[1]==cNomeComp} )
n_row:=aComponentes[n_pos,2]-1
n_col:=aComponentes[n_pos,3]
n_wdt:=aComponentes[n_pos,5]
if n_row>5
 lOk:=.T.
 for i=1 to Len(aComponentes)
  if aComponentes[i,1]!=cNomeComp
   if n_col>=aComponentes[i,3] .and. n_col<=(aComponentes[i,3]+aComponentes[i,5]) .or. ;
      (n_col+n_wdt)>=aComponentes[i,3] .and. (n_col+n_wdt)<=(aComponentes[i,3]+aComponentes[i,5])
     if n_row==aComponentes[i,2]+aComponentes[i,4]
      lOk:=.F.
      Exit
     endif
   endif
  endif
 Next
 if lOk
  SetProperty(cFormName,cNomeComp,"Row",n_row)
  aComponentes[n_pos,2]:=n_row
 endif
endif
Return

**************************************************
Proc Seta_baixo(cFormName)
Local cNomeComp:=_GetFocusedControl (cFormName), n_pos, n_row, n_col, lOk, i, n_max
n_pos:=Ascan( aComponentes, {|e| e[1]==cNomeComp} )
n_row:=aComponentes[n_pos,2]+1
n_col:=aComponentes[n_pos,3]
n_hgt:=aComponentes[n_pos,4]
n_wdt:=aComponentes[n_pos,5]
n_max:=GetProperty(cFormName,"Height")-(n_hgt+5)
if n_row<n_max
 lOk:=.T.
 for i=1 to Len(aComponentes)
  if aComponentes[i,1]!=cNomeComp
   if n_col>=aComponentes[i,3] .and. n_col<=(aComponentes[i,3]+aComponentes[i,5]) .or. ;
      (n_col+n_wdt)>=aComponentes[i,3] .and. (n_col+n_wdt)<=(aComponentes[i,3]+aComponentes[i,5])
     if n_row+n_hgt==aComponentes[i,2]
      lOk:=.F.
      Exit
     endif
   endif
  endif
 Next
 if lOk
  SetProperty(cFormName,cNomeComp,"Row",n_row)
  aComponentes[n_pos,2]:=n_row
 endif
endif
Return

**************************************************
Proc Seta_esq(cFormName)
Local cNomeComp:=_GetFocusedControl (cFormName), n_pos, n_row, n_col, lOk, i
n_pos:=Ascan( aComponentes, {|e| e[1]==cNomeComp} )
n_row:=aComponentes[n_pos,2]
n_col:=aComponentes[n_pos,3]-1
if n_col>5
 lOk:=.T.
 for i=1 to Len(aComponentes)
  if aComponentes[i,1]!=cNomeComp
   if n_row>=aComponentes[i,2] .and. n_row<=(aComponentes[i,2]+aComponentes[i,4])
     if n_col==aComponentes[i,3]+aComponentes[i,5]
      lOk:=.F.
      Exit
     endif
   endif
  endif
 Next
 if lOk
  SetProperty(cFormName,cNomeComp,"Col",n_col)
  aComponentes[n_pos,3]:=n_col
 endif
endif
Return

**************************************************
Proc Seta_dir(cFormName)
Local cNomeComp:=_GetFocusedControl (cFormName), n_pos, n_row, n_col, lOk, i
n_pos:=Ascan( aComponentes, {|e| e[1]==cNomeComp} )
n_row:=aComponentes[n_pos,2]
n_col:=aComponentes[n_pos,3]+1
n_wdt:=aComponentes[n_pos,5]
n_max:=GetProperty(cFormName,"Width")-(n_wdt+5)
if n_col<n_max
 lOk:=.T.
 for i=1 to Len(aComponentes)
  if aComponentes[i,1]!=cNomeComp
   if n_row>=aComponentes[i,2] .and. n_row<=(aComponentes[i,2]+aComponentes[i,4])
     if (n_col+n_wdt)==aComponentes[i,3]
      lOk:=.F.
      Exit
     endif
   endif
  endif
 Next
 if lOk
  SetProperty(cFormName,cNomeComp,"Col",n_col)
  aComponentes[n_pos,3]:=n_col
 endif
endif
Return

**************************************************
Func Pega_Comp(cFormName)
Local nFormHandle , i , nControlCount , x

nFormHandle := GetFormHandle ( cFormName )
nControlCount := Len ( _HMG_aControlHandles )
For i := 1 To nControlCount
   If _HMG_aControlParentHandles[i] == nFormHandle
      If ValType( _HMG_aControlHandles[i] ) == 'N'
         IF ! Empty( _HMG_aControlNames[i] )
            If Ascan( aComponentes, {|e| e[1]==_HMG_aControlNames[i] } ) == 0
               Aadd( aComponentes, {_HMG_aControlNames[i],_HMG_aControlRow[i],_HMG_aControlCol[i],_HMG_aControlHeight[i],_HMG_aControlWidth[i]} )
            EndIf
         ENDIF
      ElseIf ValType( _HMG_aControlHandles [i] ) == 'A'
         For x := 1 To Len ( _HMG_aControlHandles[i] )
            IF !Empty( _HMG_aControlNames[i] )
               If Ascan( aComponentes, {|e| e[1]==_HMG_aControlNames[i] } ) == 0
                 Aadd( aComponentes, {_HMG_aControlNames[i],_HMG_aControlRow[i],_HMG_aControlCol[i],_HMG_aControlHeight[i],_HMG_aControlWidth[i]} )
               EndIf
            ENDIF
         Next x
      EndIf
   EndIf
Next i
Return .T.